Index: cpp/frams/genetics/defgenoconv.cpp
===================================================================
--- cpp/frams/genetics/defgenoconv.cpp	(revision 196)
+++ cpp/frams/genetics/defgenoconv.cpp	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/defgenoconv.h
===================================================================
--- cpp/frams/genetics/defgenoconv.h	(revision 196)
+++ cpp/frams/genetics/defgenoconv.h	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/f1/conv_f1.cpp
===================================================================
--- cpp/frams/genetics/f1/conv_f1.cpp	(revision 196)
+++ cpp/frams/genetics/f1/conv_f1.cpp	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/f1/conv_f1.h
===================================================================
--- cpp/frams/genetics/f1/conv_f1.h	(revision 196)
+++ cpp/frams/genetics/f1/conv_f1.h	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/f4/conv_f4.cpp
===================================================================
--- cpp/frams/genetics/f4/conv_f4.cpp	(revision 196)
+++ cpp/frams/genetics/f4/conv_f4.cpp	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/f4/conv_f4.h
===================================================================
--- cpp/frams/genetics/f4/conv_f4.h	(revision 196)
+++ cpp/frams/genetics/f4/conv_f4.h	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/f4/f4_general.cpp
===================================================================
--- cpp/frams/genetics/f4/f4_general.cpp	(revision 196)
+++ cpp/frams/genetics/f4/f4_general.cpp	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/f4/f4_general.h
===================================================================
--- cpp/frams/genetics/f4/f4_general.h	(revision 196)
+++ cpp/frams/genetics/f4/f4_general.h	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/f4/oper_f4.cpp
===================================================================
--- cpp/frams/genetics/f4/oper_f4.cpp	(revision 196)
+++ cpp/frams/genetics/f4/oper_f4.cpp	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/f4/oper_f4.h
===================================================================
--- cpp/frams/genetics/f4/oper_f4.h	(revision 196)
+++ cpp/frams/genetics/f4/oper_f4.h	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/f9/conv_f9.cpp
===================================================================
--- cpp/frams/genetics/f9/conv_f9.cpp	(revision 196)
+++ cpp/frams/genetics/f9/conv_f9.cpp	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/f9/conv_f9.h
===================================================================
--- cpp/frams/genetics/f9/conv_f9.h	(revision 196)
+++ cpp/frams/genetics/f9/conv_f9.h	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/f9/oper_f9.cpp
===================================================================
--- cpp/frams/genetics/f9/oper_f9.cpp	(revision 196)
+++ cpp/frams/genetics/f9/oper_f9.cpp	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/f9/oper_f9.h
===================================================================
--- cpp/frams/genetics/f9/oper_f9.h	(revision 196)
+++ cpp/frams/genetics/f9/oper_f9.h	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/fF/conv_fF.cpp
===================================================================
--- cpp/frams/genetics/fF/conv_fF.cpp	(revision 196)
+++ cpp/frams/genetics/fF/conv_fF.cpp	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/fF/conv_fF.h
===================================================================
--- cpp/frams/genetics/fF/conv_fF.h	(revision 196)
+++ cpp/frams/genetics/fF/conv_fF.h	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/fF/fF_chamber3d.cpp
===================================================================
--- cpp/frams/genetics/fF/fF_chamber3d.cpp	(revision 196)
+++ cpp/frams/genetics/fF/fF_chamber3d.cpp	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/fF/fF_chamber3d.h
===================================================================
--- cpp/frams/genetics/fF/fF_chamber3d.h	(revision 196)
+++ cpp/frams/genetics/fF/fF_chamber3d.h	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/fF/fF_genotype.cpp
===================================================================
--- cpp/frams/genetics/fF/fF_genotype.cpp	(revision 196)
+++ cpp/frams/genetics/fF/fF_genotype.cpp	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/fF/fF_genotype.h
===================================================================
--- cpp/frams/genetics/fF/fF_genotype.h	(revision 196)
+++ cpp/frams/genetics/fF/fF_genotype.h	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/fF/oper_fF.cpp
===================================================================
--- cpp/frams/genetics/fF/oper_fF.cpp	(revision 196)
+++ cpp/frams/genetics/fF/oper_fF.cpp	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/fF/oper_fF.h
===================================================================
--- cpp/frams/genetics/fF/oper_fF.h	(revision 196)
+++ cpp/frams/genetics/fF/oper_fF.h	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/gen-config-GDK.h
===================================================================
--- cpp/frams/genetics/gen-config-GDK.h	(revision 196)
+++ cpp/frams/genetics/gen-config-GDK.h	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/genman.cpp
===================================================================
--- cpp/frams/genetics/genman.cpp	(revision 196)
+++ cpp/frams/genetics/genman.cpp	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/genman.h
===================================================================
--- cpp/frams/genetics/genman.h	(revision 196)
+++ cpp/frams/genetics/genman.h	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/geno.cpp
===================================================================
--- cpp/frams/genetics/geno.cpp	(revision 196)
+++ cpp/frams/genetics/geno.cpp	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/geno.h
===================================================================
--- cpp/frams/genetics/geno.h	(revision 196)
+++ cpp/frams/genetics/geno.h	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/genoconv.cpp
===================================================================
--- cpp/frams/genetics/genoconv.cpp	(revision 196)
+++ cpp/frams/genetics/genoconv.cpp	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/genoconv.h
===================================================================
--- cpp/frams/genetics/genoconv.h	(revision 196)
+++ cpp/frams/genetics/genoconv.h	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/oper_fx.cpp
===================================================================
--- cpp/frams/genetics/oper_fx.cpp	(revision 196)
+++ cpp/frams/genetics/oper_fx.cpp	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/oper_fx.h
===================================================================
--- cpp/frams/genetics/oper_fx.h	(revision 196)
+++ cpp/frams/genetics/oper_fx.h	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/preconfigured.h
===================================================================
--- cpp/frams/genetics/preconfigured.h	(revision 196)
+++ cpp/frams/genetics/preconfigured.h	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 